/*
 * Universal REST API
 *
 * Universal API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Currently supported protocols:  * algorand   * mainnet * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/goerli * litecoin   * mainnet/testnet * near   * mainnet/testnet * oasis   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * xrp   * mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// ProtocolsOverview struct for ProtocolsOverview
type ProtocolsOverview struct {
	// List of items each describing a pair of supported protocol and network.
	Protocols *[]ProtocolsOverviewProtocols `json:"protocols,omitempty"`
}

// NewProtocolsOverview instantiates a new ProtocolsOverview object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProtocolsOverview() *ProtocolsOverview {
	this := ProtocolsOverview{}
	return &this
}

// NewProtocolsOverviewWithDefaults instantiates a new ProtocolsOverview object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProtocolsOverviewWithDefaults() *ProtocolsOverview {
	this := ProtocolsOverview{}
	return &this
}

// GetProtocols returns the Protocols field value if set, zero value otherwise.
func (o *ProtocolsOverview) GetProtocols() []ProtocolsOverviewProtocols {
	if o == nil || o.Protocols == nil {
		var ret []ProtocolsOverviewProtocols
		return ret
	}
	return *o.Protocols
}

// GetProtocolsOk returns a tuple with the Protocols field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolsOverview) GetProtocolsOk() (*[]ProtocolsOverviewProtocols, bool) {
	if o == nil || o.Protocols == nil {
		return nil, false
	}
	return o.Protocols, true
}

// HasProtocols returns a boolean if a field has been set.
func (o *ProtocolsOverview) HasProtocols() bool {
	if o != nil && o.Protocols != nil {
		return true
	}

	return false
}

// SetProtocols gets a reference to the given []ProtocolsOverviewProtocols and assigns it to the Protocols field.
func (o *ProtocolsOverview) SetProtocols(v []ProtocolsOverviewProtocols) {
	o.Protocols = &v
}

func (o ProtocolsOverview) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Protocols != nil {
		toSerialize["protocols"] = o.Protocols
	}
	return json.Marshal(toSerialize)
}

type NullableProtocolsOverview struct {
	value *ProtocolsOverview
	isSet bool
}

func (v NullableProtocolsOverview) Get() *ProtocolsOverview {
	return v.value
}

func (v *NullableProtocolsOverview) Set(val *ProtocolsOverview) {
	v.value = val
	v.isSet = true
}

func (v NullableProtocolsOverview) IsSet() bool {
	return v.isSet
}

func (v *NullableProtocolsOverview) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProtocolsOverview(val *ProtocolsOverview) *NullableProtocolsOverview {
	return &NullableProtocolsOverview{value: val, isSet: true}
}

func (v NullableProtocolsOverview) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProtocolsOverview) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
